﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.CalcEngine;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinCalcManager.FormulaBuilder;

namespace _103972
{
    public partial class Form1 : Form
    {
        int formula = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            for (int i = 0; i < 5; i++)
            {
                dt.Columns.Add(i.ToString(), typeof(int)).DefaultValue = i+1;
            }

            for (int i = 0; i < 10; i++)
            {
                dt.Rows.Add();
            }

            ultraGrid1.DataSource = dt;
          
        }

        private bool ShowFormulaBuilderDialog(IFormulaProvider formulaProvider)
        {
           
            // Declare a new FormulaBuilderDialog
            FormulaBuilderDialog formulaBuilderDialog =
              new FormulaBuilderDialog(formulaProvider);
            // Show the dialog 
            DialogResult dResult = formulaBuilderDialog.ShowDialog(this);
            // If the user cancelled, do nothing 
            if (dResult == System.Windows.Forms.DialogResult.Cancel)
                return false;
            // Apply the formula 
            formulaProvider.Formula = formulaBuilderDialog.Formula;
            return true ;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            SummarySettings ss = ultraGrid1.DisplayLayout.Bands[0].Summaries.Add(string.Empty, string.Empty);
            if (ShowFormulaBuilderDialog(ss))
                ss.Key = string.Format("Formula{0}", formula++);
            else
                ultraGrid1.DisplayLayout.Bands[0].Summaries.Remove(ss);

        }

        private void ultraGrid1_AfterSummaryDialog(object sender, AfterSummaryDialogEventArgs e)
        {
            if (e.SummariesChanged)
            {
                ultraGrid1.DisplayLayout.Bands[0].Summaries.Cast<SummarySettings>()
                    .Where(s => s.SourceColumn.Equals(e.Column) && string.IsNullOrEmpty(s.Key)).ToList<SummarySettings>()
                    .ForEach(delegate(SummarySettings s)
                    {
                        s.Key = string.Format("[{0}]{1}", s.SummaryType.ToString(), e.Column.Header.Caption);
                    });
               
            }
        } 
    }
}
